/********************************************************************/
/* AgbDefine.h */
/* AGB Standard Constants */
/* */
/* Copyright (C) 1999-2001 NINTENDO Co.,Ltd. */
/********************************************************************/


/*------------------------------------------------------------------*/
/* Constant */
/*------------------------------------------------------------------*/
.set ON , 			1
.set OFF , 			0
.set ENABLE , 			1
.set DISABLE , 			0
.set TRUE , 			1
.set FALSE , 			0
.set LCD_WIDTH , 		240 	/* Screen Width */
.set LCD_HEIGHT , 		160 	/* Screen Height */
.set SYSTEM_CLOCK , 		(16 * 1024 * 1024) 	/* System Clock */
/*------------------------------------------------------------------*/
/* Register & RAM Reset System Call */
/*------------------------------------------------------------------*/
.set RESET_ALL_FLAG , 		0xff 	/* Reset all */
.set RESET_ALL_REG_FLAG , 	0xe0 	/* Reset all registers */
.set RESET_REG_FLAG , 		0x80 	/* Reset registers */
	/* (other than stated below) */
.set RESET_REG_SOUND_FLAG , 	0x40 	/* Reset sound register */
.set RESET_REG_SIO_FLAG , 	0x20 	/* Reset SIO register */
.set RESET_ALL_RAM_FLAG , 	0x1f 	/* Clear the entire RAM */
.set RESET_EX_WRAM_FLAG , 	0x01 	/* Clear CPU external RAM */
.set RESET_CPU_WRAM_FLAG , 	0x02 	/* Clear CPU internal RAM */
.set RESET_PLTT_FLAG , 		0x04 	/* Clear palette */
.set RESET_VRAM_FLAG , 		0x08 	/* Clear VRAM */
.set RESET_OAM_FLAG , 		0x10 	/* Clear OAM */
/*------------------------------------------------------------------*/
/* BG Screen Data */
/*------------------------------------------------------------------*/
.set BG_SC_CHAR_NO_MASK , 	0x03ff 	/* Character No */
.set BG_SC_FLIP_MASK , 		0x0c00 	/* Flip */
.set BG_SC_PLTT_MASK , 		0xf000 	/* Color Palette No */
.set BG_SC_CHAR_NO_SHIFT , 	0
.set BG_SC_FLIP_SHIFT , 	10
.set BG_SC_PLTT_SHIFT , 	12
.set BG_SC_H_FLIP , 		0x0400 	/* H Flip */
.set BG_SC_V_FLIP , 		0x0800 	/* V Flip */
/*------------------------------------------------------------------*/
/* Affine Transformation */
/*------------------------------------------------------------------*/
.set SIN_SHIFT , 		14
.set AFFINE_DIV_SHIFT , 	8
.set AFFINE_REG_SHIFT , 	8
.set AFFINE_CAL_SHIFT , 	(SIN_SHIFT + AFFINE_DIV_SHIFT - AFFINE_REG_SHIFT)
/*------------------------------------------------------------------*/
/* OAM Data */
/*------------------------------------------------------------------*/
.set OAM_V_POS_MASK , 		0x000000ff 	/* OBJ X Coordinate */
.set OAM_H_POS_MASK , 		0x01ff0000 	/* OBJ Y Coordinate */
.set OAM_SHAPE_MASK , 		0x0000c000 	/* OBJ shape */
.set OAM_SIZE_MASK , 		0xc0000000 	/* OBJ size */
.set OAM_OBJ_MODE_MASK , 	0x00000c00 	/* OBJ Mode */
.set OAM_AFFINE_MODE_MASK , 	0x00000300 	/* Affine Mode */
.set OAM_AFFINE_NO_MASK , 	0x3e000000 	/* Affine Parameter No */
.set OAM_FLIP_MASK , 		0x30000000 	/* Flip */
.set OAM_CHAR_NO_MASK , 	0x000003ff 	/* Character No */
.set OAM_PRIORITY_MASK , 	0x00000c00 	/* BG Relative Priority */
.set OAM_PLTT_MASK , 		0x0000f000 	/* Color Palette No */
.set OAM_AFFINE_PARAM_MASK , 	0xffff0000 	/* Affine Parameter */
.set OAM_V_POS_SHIFT , 		0
.set OAM_H_POS_SHIFT , 		16
.set OAM_SHAPE_SHIFT , 		14
.set OAM_SIZE_SHIFT , 		30
.set OAM_AFFINE_MODE_SHIFT , 	8
.set OAM_OBJ_MODE_SHIFT , 	10
.set OAM_AFFINE_NO_SHIFT , 	25
.set OAM_FLIP_SHIFT , 		28
.set OAM_CHAR_NO_SHIFT , 	0
.set OAM_PRIORITY_SHIFT , 	10
.set OAM_PLTT_SHIFT , 		12
.set OAM_AFFINE_PARAM_SHIFT , 	16
.set OAM_OBJ_ON , 		0x00000000 	/* OBJ ON */
.set OAM_OBJ_OFF , 		0x00000200 	/* OBJ OFF */
.set OAM_OBJ_NORMAL , 		0x00000000 	/* OBJ Normal Mode */
.set OAM_OBJ_BLEND , 		0x00000400 	/* OBJ Semi-transparent Mode */
.set OAM_OBJ_WINDOW , 		0x00000800 	/* OBJ Window Mode */
.set OAM_AFFINE_NONE , 		0x00000000 	/* Affine Invalid Mode */
.set OAM_AFFINE_NORMAL , 	0x00000100 	/* Affine Normal Mode */
.set OAM_AFFINE_TWICE , 	0x00000300 	/* Affine Double-size Mode */
.set OAM_AFFINE_ERASE , 	0x00000200 	/* Affine non-display Mode */
.set OAM_MOS_ON , 		0x00001000 	/* Mosaic ON */
.set OAM_MOS_OFF , 		0x00000000 	/* Mosaic OFF */
.set OAM_COLOR_16 , 		0x00000000 	/* Select 16 */
.set OAM_COLOR_256 , 		0x00002000 	/* Select 256 colors */
.set OAM_H_FLIP , 		0x10000000 	/* H Flip */
.set OAM_V_FLIP , 		0x20000000 	/* V Flip */
.set OAM_SQUARE , 		0x00000000 	/* Square OBJ */
.set OAM_H_RECTANGLE , 		0x00004000 	/* Horizontally-oriented rectangle OBJ */
.set OAM_V_RECTANGLE , 		0x00008000 	/* Vertically-oriented rectangle OBJ */
.set OAM_SIZE_NO_0 , 		0x00000000 	/* OBJ size No 0 */
.set OAM_SIZE_NO_1 , 		0x40000000 	/* OBJ size No 1 */
.set OAM_SIZE_NO_2 , 		0x80000000 	/* OBJ size No 2 */
.set OAM_SIZE_NO_3 , 		0xc0000000 	/* OBJ size No 3 */
.set OAM_SIZE_8x8 , 		0x00000000 	/* OBJ 8 x 8 dot */
.set OAM_SIZE_16x16 , 		0x40000000 	/* OBJ 16 x 16 dot */
.set OAM_SIZE_32x32 , 		0x80000000 	/* OBJ 32 x 32 dot */
.set OAM_SIZE_64x64 , 		0xc0000000 	/* OBJ 64 x 64 dot */
.set OAM_SIZE_16x8 , 		0x00004000 	/* OBJ 16 x 8 dot */
.set OAM_SIZE_32x8 , 		0x40004000 	/* OBJ 32 x 8 dot */
.set OAM_SIZE_32x16 , 		0x80004000 	/* OBJ 32 x 16 dot */
.set OAM_SIZE_64x32 , 		0xc0004000 	/* OBJ 64 x 32 dot */
.set OAM_SIZE_8x16 , 		0x00008000 	/* OBJ 8 x 16 dot */
.set OAM_SIZE_8x32 , 		0x40008000 	/* OBJ 8 x 32 dot */
.set OAM_SIZE_16x32 , 		0x80008000 	/* OBJ 16 x 32 dot */
.set OAM_SIZE_32x64 , 		0xc0008000 	/* OBJ 32 x 64 dot */
/*------------------------------------------------------------------*/
/* Color Palette Data */
/*------------------------------------------------------------------*/
.set PLTT_RED_MASK , 		0x001f 	/* Red */
.set PLTT_GREEN_MASK , 		0x03e0 	/* Green */
.set PLTT_BLUE_MASK , 		0x7c00 	/* Blue */
.set PLTT_RED_SHIFT , 		0
.set PLTT_GREEN_SHIFT , 	5
.set PLTT_BLUE_SHIFT , 		10
/********************************************************************/
/* AGB Register Control Bit */
/********************************************************************/
/*------------------------------------------------------------------*/
/* Program Status Register */
/*------------------------------------------------------------------*/
.set PSR_CPU_MODE_MASK , 	0x1f 	/* CPU Mode */
.set PSR_USER_MODE , 		0x10 	/* User */
.set PSR_FIQ_MODE , 		0x11 	/* FIQ */
.set PSR_IRQ_MODE , 		0x12 	/* IRQ */
.set PSR_SVC_MODE , 		0x13 	/* Supervisor */
.set PSR_ABORT_MODE , 		0x17 	/* Abort (Prefetch/Data) */
.set PSR_UNDEF_MODE , 		0x1b 	/* Undefined Command */
.set PSR_SYS_MODE , 		0x1f 	/* System */
.set PSR_THUMB_STATE , 		0x20 	/* THUMB State */
.set PSR_FIQ_DISABLE , 		0x40 	/* FIQ Disable */
.set PSR_IRQ_DISABLE , 		0x80 	/* IRQ Disable */
.set PSR_IRQ_FIQ_DISABLE , 	0xc0 	/* IRQ & FIQ Disable */
.set PSR_V_FLAG , 		0x10000000 	/* Overflow */
.set PSR_C_FLAG , 		0x20000000 	/* Carry/Borrow/Extend */
.set PSR_Z_FLAG , 		0x40000000 	/* Zero */
.set PSR_N_FLAG , 		0x80000000 	/* Negative/Less Than */
/*------------------------------------------------------------------*/
/* Interrupt Request/ Enable Flag */
/*------------------------------------------------------------------*/
.set V_BLANK_INTR_FLAG , 	0x0001 	/* V Blank Interrupt */
.set H_BLANK_INTR_FLAG , 	0x0002 	/* H Blank Interrupt */
.set V_COUNT_INTR_FLAG , 	0x0004 	/* V Counter Corresponding Interrupt */
.set TIMER0_INTR_FLAG , 	0x0008 	/* Timer 0 Interrupt */
.set TIMER1_INTR_FLAG , 	0x0010 	/* Timer 1 Interrupt */
.set TIMER2_INTR_FLAG , 	0x0020 	/* Timer 2 Interrupt */
.set TIMER3_INTR_FLAG , 	0x0040 	/* Timer 3 Interrupt */
.set SIO_INTR_FLAG , 		0x0080 	/* Serial Communication Interrupt */
.set DMA0_INTR_FLAG , 		0x0100 	/* DMA0 Interrupt */
.set DMA1_INTR_FLAG , 		0x0200 	/* DMA1 Interrupt */
.set DMA2_INTR_FLAG , 		0x0400 	/* DMA2 Interrupt */
.set DMA3_INTR_FLAG , 		0x0800 	/* DMA3 Interrupt */
.set KEY_INTR_FLAG , 		0x1000 	/* Key Interrupt */
.set CASSETTE_INTR_FLAG , 	0x2000 	/* Game Pak Interrupt */
/*------------------------------------------------------------------*/
/* Display Control */
/*------------------------------------------------------------------*/
.set DISP_BG_MODE_MASK , 	0x0007 	/* BG Mode */
.set DISP_ON_MASK , 		0x1f00 	/* OBJ BG ON */
.set DISP_WIN_MASK , 		0x6000 	/* Window ON */
.set DISP_BG_MODE_SHIFT , 	0
.set DISP_ON_SHIFT , 		8
.set DISP_WIN_SHIFT , 		13
.set DISP_MODE_0 , 		0x0000 	/* BG Mode 0 */
.set DISP_MODE_1 , 		0x0001 	/* BG Mode 1 */
.set DISP_MODE_2 , 		0x0002 	/* BG Mode 2 */
.set DISP_MODE_3 , 		0x0003 	/* BG Mode 3 */
.set DISP_MODE_4 , 		0x0004 	/* BG Mode 4 */
.set DISP_MODE_5 , 		0x0005 	/* BG Mode 5 */
.set DISP_BMP_FRAME_NO , 	0x0010 	/* Bitmap Mode Display Frame */
.set DISP_OBJ_HOFF , 		0x0020 	/* OBJ Processing in H Blank OFF */
.set DISP_OBJ_CHAR_2D_MAP , 	0x0000 	/* OBJ Character Data 2D Mapping */
.set DISP_OBJ_CHAR_1D_MAP , 	0x0040 	/* OBJ Character Data 1D Mapping */
.set DISP_LCDC_OFF , 		0x0080 	/* LCDC OFF */
.set DISP_BG0_ON , 		0x0100 	/* BG0 ON */
.set DISP_BG1_ON , 		0x0200 	/* BG1 ON */
.set DISP_BG2_ON , 		0x0400 	/* BG2 ON */
.set DISP_BG3_ON , 		0x0800 	/* BG3 ON */
.set DISP_BG_ALL_ON , 		0x0f00 	/* All BG ON */
.set DISP_OBJ_ON , 		0x1000 	/* OBJ ON */
.set DISP_OBJ_BG_ALL_ON , 	0x1f00 	/* All OBJ/BG ON */
.set DISP_WIN0_ON , 		0x2000 	/* Window 0 ON */
.set DISP_WIN1_ON , 		0x4000 	/* Window 1 ON */
.set DISP_WIN01_ON , 		0x6000 	/* Window 0,1 ON */
.set DISP_OBJWIN_ON , 		0x8000 	/* OBJ Window ON */
.set DISP_WIN_ALL_ON , 		0xe000 	/* All Window ON */
.set DISP_ALL_ON , 		0x7f00 	/* All ON */
/*------------------------------------------------------------------*/
/* Status Control */
/*------------------------------------------------------------------*/
.set STAT_VCOUNT_CMP_MASK , 	0xff00 	/* V Counter Compare Value */
.set STAT_VCOUNT_CMP_SHIFT , 	8
.set STAT_V_BLANK , 		0x0001 	/* During V Blank */
.set STAT_H_BLANK , 		0x0002 	/* During H Blank */
.set STAT_V_COUNT , 		0x0004 	/* Matching with V Counter */
.set STAT_V_BLANK_IF_ENABLE , 	0x0008 	/* V Blank Interrupt Request, Enable */
.set STAT_H_BLANK_IF_ENABLE , 	0x0010 	/* H Blank Interrupt Request, Enable */
.set STAT_V_COUNT_IF_ENABLE , 	0x0020 	/* V Counter Corresponding */
	/* Interrupt Request, Enable */
/*------------------------------------------------------------------*/
/* BG Control */
/*------------------------------------------------------------------*/
.set BG_PRIORITY_MASK , 	0x0003 	/* BG Priority */
.set BG_CHAR_BASE_MASK , 	0x000c 	/* Character Base Address */
.set BG_SCREEN_BASE_MASK , 	0x1f00 	/* Screen Base Address */
.set BG_SCREEN_SIZE_MASK , 	0xc000 	/* Screen Size (256/512) */
.set BG_PRIORITY_SHIFT , 	0
.set BG_CHAR_BASE_SHIFT , 	2
.set BG_SCREEN_BASE_SHIFT , 	8
.set BG_SCREEN_SIZE_SHIFT , 	14
.set BG_PRIORITY_0 , 		0x0000 	/* BG 0 Priority */
.set BG_PRIORITY_1 , 		0x0001 	/* BG 1 Priority */
.set BG_PRIORITY_2 , 		0x0002 	/* BG 2 Priority */
.set BG_PRIORITY_3 , 		0x0003 	/* BG 3 Priority */
.set BG_MOS_ON , 		0x0040 	/* Mosaic ON */
.set BG_MOS_OFF , 		0x0000 	/* Mosaic OFF */
.set BG_COLOR_16 , 		0x0000 	/* Select 16 colors */
.set BG_COLOR_256 , 		0x0080 	/* Select 256 colors */
.set BG_LOOP_ON , 		0x2000 	/* Loop ON */
.set BG_LOOP_OFF , 		0x0000 	/* Loop OFF */
.set BG_SCREEN_SIZE_0 , 	0x0000 	/* Screen Size (256x256) */
.set BG_SCREEN_SIZE_1 , 	0x4000 	/* Screen Size (512x256) */
.set BG_SCREEN_SIZE_2 , 	0x8000 	/* Screen Size (256x512) */
.set BG_SCREEN_SIZE_3 , 	0xc000 	/* Screen Size (512x512) */
/*------------------------------------------------------------------*/
/* Window Control */
/*------------------------------------------------------------------*/
.set WIN_END_POS_MASK , 	0x00ff 	/* Window End Position */
.set WIN_START_POS_MASK , 	0xff00 	/* Window Start Position */
.set WIN_END_POS_SHIFT , 	0
.set WIN_START_POS_SHIFT , 	8
.set WIN_BG0_ON , 		0x0001 	/* BG0 ON */
.set WIN_BG1_ON , 		0x0002 	/* BG1 ON */
.set WIN_BG2_ON , 		0x0004 	/* BG2 ON */
.set WIN_BG3_ON , 		0x0008 	/* BG3 ON */
.set WIN_OBJ_ON , 		0x0010 	/* OBJ ON */
.set WIN_BLEND_ON , 		0x0020 	/* Blend ON */
.set WIN_ALL_ON , 		0x003f 	/* All ON */
/*------------------------------------------------------------------*/
/* Mosaic Control */
/*------------------------------------------------------------------*/
.set MOS_H_SIZE_MASK , 		0x000f 	/* Mosaic Height */
.set MOS_V_SIZE_MASK , 		0x00f0 	/* Mosaic Width */
.set MOS_BG_H_SIZE_MASK , 	0x000f 	/* BG Mosaic Height */
.set MOS_BG_V_SIZE_MASK , 	0x00f0 	/* BG Mosaic Width */
.set MOS_OBJ_H_SIZE_MASK , 	0x000f 	/* OBJ Mosaic Height */
.set MOS_OBJ_V_SIZE_MASK , 	0x00f0 	/* OBJ Mosaic Width */
.set MOS_H_SIZE_SHIFT , 	0
.set MOS_V_SIZE_SHIFT , 	4
.set MOS_BG_H_SIZE_SHIFT , 	0
.set MOS_BG_V_SIZE_SHIFT , 	4
.set MOS_OBJ_H_SIZE_SHIFT , 	8
.set MOS_OBJ_V_SIZE_SHIFT , 	12
/*------------------------------------------------------------------*/
/* Blend Control */
/*------------------------------------------------------------------*/
.set BLD_PIXEL_MASK , 		0x003f 	/* Select Pixel */
.set BLD_1ST_PIXEL_MASK , 	0x003f 	/* Select 1st Pixel */
.set BLD_MODE_MASK , 		0x00c0 	/* Blend Mode */
.set BLD_2ND_PIXEL_MASK , 	0x3f00 	/* Select 2nd Pixel */
.set BLD_1ST_PIXEL_SHIFT , 	0
.set BLD_MODE_SHIFT , 		6
.set BLD_2ND_PIXEL_SHIFT , 	8
.set BLD_BG0 , 			0x0001 	/* Select BG0 Pixel */
.set BLD_BG1 , 			0x0002 	/* Select BG1 Pixel */
.set BLD_BG2 , 			0x0004 	/* Select BG2 Pixel */
.set BLD_BG3 , 			0x0008 	/* Select BG3 Pixel */
.set BLD_OBJ , 			0x0010 	/* Select OBJ Pixel */
.set BLD_BD , 			0x0020 	/* Select Background Color Pixel */
.set BLD_ALL , 			0x003f 	/* Select All Pixels */
.set BLD_BG0_1ST , 		0x0001 	/* Select BG0 1st Pixel */
.set BLD_BG1_1ST , 		0x0002 	/* Select BG1 1st Pixel */
.set BLD_BG2_1ST , 		0x0004 	/* Select BG2 1st Pixel */
.set BLD_BG3_1ST , 		0x0008 	/* Select BG3 1st Pixel */
.set BLD_OBJ_1ST , 		0x0010 	/* Select OBJ 1st Pixel */
.set BLD_BD_1ST , 		0x0020 	/* Select Background Color 1st Pixel */
.set BLD_1ST_ALL , 		0x003f 	/* Select All 1st Pixel */
.set BLD_NORMAL_MODE , 		0x0000 	/* Normal Mode */
.set BLD_A_BLEND_MODE , 	0x0040 	/* Semi-transparent Mode */
.set BLD_UP_MODE , 		0x0080 	/* Brightness UP Mode */
.set BLD_DOWN_MODE , 		0x00c0 	/* Brightness DOWN Mode */
.set BLD_BG0_2ND , 		0x0100 	/* Select BG0 2nd Pixel */
.set BLD_BG1_2ND , 		0x0200 	/* Select BG1 2nd Pixel */
.set BLD_BG2_2ND , 		0x0400 	/* Select BG2 2nd Pixel */
.set BLD_BG3_2ND , 		0x0800 	/* Select BG3 2nd Pixel */
.set BLD_OBJ_2ND , 		0x1000 	/* Select OBJ 2nd Pixel */
.set BLD_BD_2ND , 		0x2000 	/* Select Background color 2nd Pixel */
.set BLD_2ND_ALL , 		0x3f00 	/* Select All 2nd Pixel */
.set BLD_A_MASK , 		0x001f 	/* Blend Variable A */
.set BLD_B_MASK , 		0x1f00 	/* Blend Variable B */
.set BLD_Y_MASK , 		0x001f 	/* Blend Variable Y */
.set BLD_A_SHIFT , 		16
.set BLD_B_SHIFT , 		24
.set BLD_Y_SHIFT , 		0
/*------------------------------------------------------------------*/
/* Sound Control */
/*------------------------------------------------------------------*/
.set SOUND_SO1_LEVEL_MASK , 	0x03 	/* S01 Output Level */
.set SOUND_SO2_LEVEL_MASK , 	0x30 	/* S02 Output Level */
.set SOUND_DMG_SO1_ON_MASK , 	0x0f 	/* DMG Compatible Sound->S01 ON */
.set SOUND_DMG_SO2_ON_MASK , 	0xf0 	/* DMG Compatible Sound->S02 ON */
.set SOUND_SWEEP_SHIFT_MASK , 	0x03 	/* Sweep Shift Number */
.set SOUND_SWEEP_TIME_MASK , 	0x30 	/* Sweep Time */
.set SOUND_COUNTS_MASK , 	0x3f 	/* Sound Length (Count Number) */
.set SOUND_DUTY_MASK , 		0xc0 	/* Waveform Duty */
.set SOUND_ENV_STEPS_MASK , 	0x03 	/* Envelope Step Number */
.set SOUND_ENV_INIT_MASK , 	0xf0 	/* Envelope Initial-Value */
.set SOUND_FREQUENCY_MASK , 	0x03ff 	/* Frequency */
.set SOUND_FREQUENCY_L_MASK , 	0xff
.set SOUND_FREQUENCY_H_MASK , 	0x03
.set SOUND_3_COUNTS_MASK , 	0xff 	/* Sound 3 Length (Count Number) */
.set SOUND_3_LEVEL_MASK , 	0xe0 	/* Output Level */
.set SOUND_4_PRESCALER_MASK , 	0x03 	/* Sound 4 Prescaler Select */
.set SOUND_4_POLYSHIFT_MASK , 	0xf0 	/* Polynomical Counter Shift Number */
.set SOUND_SO1_LEVEL_SHIFT , 	0
.set SOUND_SO2_LEVEL_SHIFT , 	4
.set SOUND_DMG_SO1_ON_SHIFT , 	0
.set SOUND_DMG_SO2_ON_SHIFT , 	4
.set SOUND_SWEEP_SHIFT_SHIFT , 	0
.set SOUND_SWEEP_TIME_SHIFT , 	4
.set SOUND_COUNTS_SHIFT , 	0
.set SOUND_DUTY_SHIFT , 	6
.set SOUND_ENV_STEPS_SHIFT , 	0
.set SOUND_ENV_INIT_SHIFT , 	4
.set SOUND_FREQUENCY_SHIFT , 	0
.set SOUND_FREQUENCY_L_SHIFT , 	0
.set SOUND_FREQUENCY_H_SHIFT , 	8
.set SOUND_3_COUNTS_SHIFT , 	0
.set SOUND_3_LEVEL_SHIFT , 	5
.set SOUND_4_PRESCALER_SHIFT , 	0
.set SOUND_4_POLYSHIFT_SHIFT , 	4
.set SOUND_1_ON , 		0x01 	/* Sound 1 ON */
.set SOUND_2_ON , 		0x02 	/* Sound 2 ON */
.set SOUND_3_ON , 		0x04 	/* Sound 3 ON */
.set SOUND_4_ON , 		0x08 	/* Sound 4 ON */
.set SOUND_DMG_ON , 		0x80 	/* DMG Compatible Sound ON */
.set SOUND_1_SO1_ON , 		0x01 	/* Sound 1 -> S01 ON */
.set SOUND_2_SO1_ON , 		0x02 	/* Sound 2 -> S01 ON */
.set SOUND_3_SO1_ON , 		0x04 	/* Sound 3 -> S01 ON */
.set SOUND_4_SO1_ON , 		0x08 	/* Sound 4 -> S01 ON */
.set SOUND_1_SO2_ON , 		0x10 	/* Sound 1 -> S02 ON */
.set SOUND_2_SO2_ON , 		0x20 	/* Sound 2 -> S02 ON */
.set SOUND_3_SO2_ON , 		0x40 	/* Sound 3 -> S02 ON */
.set SOUND_4_SO2_ON , 		0x80 	/* Sound 4 -> S02 ON */
.set SOUND_DMG_ALL_SO1_ON , 	0x0f 	/* DMG Compatible Sound -> S01 ON */
.set SOUND_DMG_ALL_SO2_ON , 	0xf0 	/* DMG Compatible Sound -> S02 ON */
.set SOUND_DMG_ALL_SO_ON , 	0xff 	/* DMG Compatible Sound -> S01/2 ON */
.set SOUND_VIN_SO1_ON , 	0x80 	/* Vin -> S01 ON */
.set SOUND_VIN_SO2_ON , 	0x08 	/* Vin -> S02 ON */
.set SOUND_VIN_SO_ON , 		0x08 	/* Vin -> S01/2 ON */
.set SOUND_A_SO1_ON , 		0x01 	/* Direct Sound A -> S01 ON */
.set SOUND_A_SO2_ON , 		0x02 	/* Direct Sound A -> S02 ON */
.set SOUND_B_SO1_ON , 		0x10 	/* Direct Sound B -> S01 ON */
.set SOUND_B_SO2_ON , 		0x20 	/* Direct Sound B -> S02 ON */
.set SOUND_A_ALL_SO_ON , 	0x03 	/* Direct Sound A -> S01/2 ON */
.set SOUND_B_ALL_SO_ON , 	0x30 	/* Direct Sound B -> S01/2 ON */
.set SOUND_DIRECT_ALL_SO1_ON , 	0x11 	/* Direct Sound A/B -> S01 ON */
.set SOUND_DIRECT_ALL_SO2_ON , 	0x22 	/* Direct Sound A/B -> S02 ON */
.set SOUND_DIRECT_ALL_SO_ON , 	0x33 	/* Direct Sound A/B -> S01/2 ON */
.set SOUND_A_TIMER_0 , 		0x00 	/* Timer 0 -> Direct Sound A */
.set SOUND_A_TIMER_1 , 		0x04 	/* Timer 1 -> Direct Sound A */
.set SOUND_B_TIMER_0 , 		0x00 	/* Timer 0 -> Direct Sound B */
.set SOUND_B_TIMER_1 , 		0x40 	/* Timer 1 -> Direct Sound B */
.set SOUND_A_FIFO_RESET , 	0x08 	/* Direct Sound A FIFO Reset */
.set SOUND_B_FIFO_RESET , 	0x80 	/* Direct Sound B FIFO Reset */
.set SOUND_DMG_MIX_1_4 , 	0x00 	/* DMG Compatible Sound Mix Ratio 1/4 */
.set SOUND_DMG_MIX_2_4 , 	0x01 	/* 2/4 */
.set SOUND_DMG_MIX_FULL , 	0x02 	/* Full Range */
.set SOUND_A_MIX_1_2 , 		0x00 	/* Direct Sound A Mix Ratio 1/2 */
.set SOUND_A_MIX_FULL , 	0x04 	/* Full Range */
.set SOUND_B_MIX_1_2 , 		0x00 	/* Direct Sound B Mix Ratio 1/2 */
.set SOUND_B_MIX_FULL , 	0x08 	/* Full Range */
.set SOUND_ALL_MIX_FULL , 	0x0e 	/* All Sound Mix Ratio Full Range */
.set SOUND_INIT_ON , 		0x80 	/* Initial ON */
.set SOUND_INIT_OFF , 		0x00 	/* Initial ON */
.set SOUND_COUNTER_ON , 	0x40 	/* Counter ON */
.set SOUND_COUNTER_OFF , 	0x00 	/* Counter OFF */
.set SOUND_SWEEP_UP , 		0x00 	/* Sweep Addition */
.set SOUND_SWEEP_DOWN , 	0x08 	/* Subtraction */
.set SOUND_DUTY_1_8 , 		0x00 	/* Waveform Duty 1/8 */
.set SOUND_DUTY_2_8 , 		0x40 	/* 2/8 */
.set SOUND_DUTY_4_8 , 		0x80 	/* 4/8 */
.set SOUND_DUTY_6_8 , 		0xc0 	/* 6/8 */
.set SOUND_ENV_UP , 		0x08 	/* Envelope UP */
.set SOUND_ENV_DOWN , 		0x00 	/* DOWN */
.set SOUND_3_LOCAL_ON , 	0x80 	/* Sound 3 ON */
.set SOUND_3_WAVE_BANK_0 , 	0x00 	/* Sound 3 Waveform RAM Bank 0 */
.set SOUND_3_WAVE_BANK_1 , 	0x40 	/* Bank 1 */
.set SOUND_3_WAVE_CONNECT , 	0x20 	/* Sound 3 Waveform RAM Connect */
.set SOUND_3_WAVE_DISCONNECT , 	0x00 	/* Disconnect */
.set SOUND_3_LEVEL_0_4 , 	0x00 	/* Sound 3 Output None */
.set SOUND_3_LEVEL_FULL , 	0x20 	/* 4/4 */
.set SOUND_3_LEVEL_2_4 , 	0x40 	/* 2/4 */
.set SOUND_3_LEVEL_1_4 , 	0x60 	/* 1/4 */
.set SOUND_3_LEVEL_3_4 , 	0x80 	/* 3/4 */
.set SOUND_4_POLYSTEP_15 , 	0x00 	/* Sound 4 Polynomical Counter 15 step */
.set SOUND_4_POLYSTEP_7 , 	0x08 	/* 7 step */
/*------------------------------------------------------------------*/
/* SIO Control */
/*------------------------------------------------------------------*/
.set SIO_MODE_MASK , 		0x3000 	/* Communication mode */
.set SIO_BAUD_RATE_MASK , 	0x0003 	/* Baud rate */
.set SIO_ID_NO_MASK , 		0x0030 	/* Communication ID */
.set SIO_MODE_SHIFT , 		12
.set SIO_BAUD_RATE_SHIFT , 	0
.set SIO_ID_NO_SHIFT , 		4
.set SIO_8BIT_MODE , 		0x0000 	/* Normal 8-bit communication mode */
.set SIO_32BIT_MODE , 		0x1000 	/* Normal 32-bit communication mode */
.set SIO_MULTI_MODE , 		0x2000 	/* Multi-play communication mode */
.set SIO_UART_MODE , 		0x3000 	/* UART communication mode */
.set SIO_SCK_OUT , 		0x0000 	/* Select external clock */
.set SIO_SCK_IN , 		0x0001 	/* Select internal clock */
.set SIO_IN_SCK_256K , 		0x0000 	/* Select internal clock 256KHz */
.set SIO_IN_SCK_2M , 		0x0002 	/* Select 2MHz */
.set SIO_ACK_RECV , 		0x0004 	/* Request transfer */
.set SIO_ACK_SEND , 		0x0008 	/* Enable transfer */
.set SIO_9600_BPS , 		0x0000 	/* Baud rate 9600 bps */
.set SIO_38400_BPS , 		0x0001 	/* 38400 bps */
.set SIO_57600_BPS , 		0x0002 	/* 57600 bps */
.set SIO_115200_BPS , 		0x0003 	/* 115200 bps */
.set SIO_MULTI_CONNECT , 	0x0004 	/* Connecting multi-play communication */
.set SIO_MULTI_DISCONNECT , 	0x0000 	/* Disconnect */
.set SIO_MULTI_PARENT , 	0x0008 	/* Multi-play communication Connect master */
.set SIO_MULTI_CHILD , 		0x0000 	/* Connect slave */
.set SIO_MULTI_SI , 		0x0004 	/* Multi-play communication SI terminal */
.set SIO_MULTI_SD , 		0x0008 	/* SD terminal */
.set SIO_MULTI_BUSY , 		0x0080 	/* Multi-play communicating */
.set SIO_CTS_ENABLE , 		0x0004 	/* Enable UART send enable signal */
.set SIO_UART_7BIT , 		0x0000 	/* UART communication data length 7 bit */
.set SIO_UART_8BIT , 		0x0080 	/* 8 bit */
.set SIO_ERROR , 		0x0040 	/* Detect error */
.set SIO_START , 		0x0080 	/* Start transfer */
.set SIO_ENABLE , 		0x0080 	/* Enable SIO */
.set SIO_FIFO_ENABLE , 		0x0100 	/* Enable FIFO */
.set SIO_PARITY_ENABLE , 	0x0200 	/* Enable parity */
.set SIO_PARITY_EVEN , 		0x0000 	/* Even parity */
.set SIO_PARITY_ODD , 		0x0008 	/* Odd parity */
.set SIO_TRANS_ENABLE , 	0x0400 	/* Enable transmitter */
.set SIO_TRANS_DATA_FULL , 	0x0010 	/* Transmitted data full */
.set SIO_RECV_ENABLE , 		0x0800 	/* Enable receiver */
.set SIO_RECV_DATA_EMPTY , 	0x0020 	/* No data received */
.set SIO_IF_ENABLE , 		0x4000 	/* Enable interrupt request */
/*------------------------------------------------------------------*/
/* JOY Bus Control */
/*------------------------------------------------------------------*/
.set JOY_IF_RESET , 		0x01 	/* Interrupt request of JOY bus reset */
.set JOY_IF_RECV , 		0x02 	/* Interrupt request of JOY bus receive completion */
.set JOY_IF_SEND , 		0x04 	/* Interrupt request of JOY bus send completion */
.set JOY_IF_ENABLE , 		0x40 	/* Enable interrupt request */
/*------------------------------------------------------------------*/
/* JOY Bus Status */
/*------------------------------------------------------------------*/
.set JSTAT_FLAGS_MASK , 	0x30 	/* General flag */
.set JSTAT_FLAGS_SHIFT , 	4
.set JSTAT_RECV , 		0x02 	/* Receive status */
.set JSTAT_SEND , 		0x08 	/* Send status */
/*------------------------------------------------------------------*/
/* General Input/Output Control */
/*------------------------------------------------------------------*/
.set R_SIO_MODE_MASTER_MASK , 	0xc000 	/* SIO mode master */
.set R_SIO_MODE_MASTER_SHIFT , 	14
.set R_SIO_MASTER_MODE , 	0x0000 	/* SIO master mode */
.set R_DIRECT_MODE , 		0x8000 	/* General input/output */
	/* communication mode */
.set R_JOY_MODE , 		0xc000 	/* JOY communication mode */
.set R_SC , 			0x0001 	/* Data */
.set R_SD , 			0x0002
.set R_SI , 			0x0004
.set R_SO , 			0x0008
.set R_SC_I_O , 		0x0010 	/* Select I/O */
.set R_SD_I_O , 		0x0020
.set R_SI_I_O , 		0x0040
.set R_SO_I_O , 		0x0080
.set R_SC_IN , 			0x0000 	/* Input setting */
.set R_SD_IN , 			0x0000
.set R_SI_IN , 			0x0000
.set R_SO_IN , 			0x0000
.set R_SC_OUT , 		0x0010 	/* Output setting */
.set R_SD_OUT , 		0x0020
.set R_SI_OUT , 		0x0040
.set R_SO_OUT , 		0x0080
.set R_IF_ENABLE , 		0x0100 	/* Enable interrupt request */
/*------------------------------------------------------------------*/
/* DMG Control */
/*------------------------------------------------------------------*/
.set DMA_TIMMING_MASK , 	0x30000000 	/* Start Timing */
.set DMA_COUNT_MASK , 		0x0000ffff 	/* Transmission Count */
.set DMA_TIMMING_SHIFT , 	30
.set DMA_COUNT_SHIFT , 		0
.set DMA_ENABLE , 		0x80000000 	/* DMA Enable */
.set DMA_IF_ENABLE , 		0x40000000 	/* Interrupt Request Enable */
.set DMA_TIMMING_IMM , 		0x00000000 	/* Run Immediately */
.set DMA_TIMMING_V_BLANK , 	0x10000000 	/* Run V Blank */
.set DMA_TIMMING_H_BLANK , 	0x20000000 	/* Run H Blank */
.set DMA_TIMMING_DISP , 	0x30000000 	/* Run Display */
.set DMA_TIMMING_SOUND , 	0x30000000 	/* Run Sound FIFO Request */
.set DMA_DREQ_ON , 		0x08000000 	/* Data Request Synchronize Mode ON */
.set DMA_16BIT_BUS , 		0x00000000 	/* Select Bus Size 16Bit */
.set DMA_32BIT_BUS , 		0x04000000 	/* Select Bus Size 32Bit */
.set DMA_CONTINUOUS_ON , 	0x02000000 	/* Continuous Mode ON */
.set DMA_SRC_INC , 		0x00000000 	/* Select Source Increment */
.set DMA_SRC_DEC , 		0x00800000 	/* Select Source Decrement */
.set DMA_SRC_FIX , 		0x01000000 	/* Select Source Fixed */
.set DMA_DEST_INC , 		0x00000000 	/* Select Destination Increment */
.set DMA_DEST_DEC , 		0x00200000 	/* Select Destination Decrement */
.set DMA_DEST_FIX , 		0x00400000 	/* Select Destination Fixed */
.set DMA_DEST_RELOAD , 		0x00600000 	/* Select Destination */
	/* Increment/Reload */
/*------------------------------------------------------------------*/
/* Timer Control */
/*------------------------------------------------------------------*/
.set TMR_PRESCALER_MASK , 	0x00030000 	/* Prescaler Clock */
.set TMR_PRESCALER_SHIFT , 	16
.set TMR_PRESCALER_1CK , 	0x00000000 	/* Prescaler 1 Clock */
.set TMR_PRESCALER_64CK , 	0x00010000 	/* 64 clocks */
.set TMR_PRESCALER_256CK , 	0x00020000 	/* 256 clocks */
.set TMR_PRESCALER_1024CK , 	0x00030000 	/* 1024 clocks */
.set TMR_IF_ENABLE , 		0x00400000 	/* Interrupt Request Enable */
.set TMR_ENABLE , 		0x00800000 	/* Run Timer */
/*------------------------------------------------------------------*/
/* Key */
/*------------------------------------------------------------------*/
.set BUTTON_MASK , 		0x030f 	/* Button */
.set PLUS_KEY_MASK , 		0x00f0 	/* +Control Pad */
.set ALL_KEY_MASK , 		0x03ff 	/* All Key */
.set A_BUTTON , 		0x0001 	/* A Button */
.set B_BUTTON , 		0x0002 	/* B Button */
.set SELECT_BUTTON , 		0x0004 	/* SELECT */
.set START_BUTTON , 		0x0008 	/* START */
.set R_KEY , 			0x0010 	/* Right Button */
.set L_KEY , 			0x0020 	/* Left Button */
.set U_KEY , 			0x0040 	/* Up Button */
.set D_KEY , 			0x0080 	/* Down Button */
.set R_BUTTON , 		0x0100 	/* R Button */
.set L_BUTTON , 		0x0200 	/* L Button */
.set KEY_IF_ENABLE , 		0x4000 	/* Interrupt Request Enable */
.set KEY_OR_INTR , 		0x0000 	/* Normal Key Interrupt */
.set KEY_AND_INTR , 		0x8000 	/* AND Key Interrupt */
/*------------------------------------------------------------------*/
/* Game Pak Wait Control */
/*------------------------------------------------------------------*/
.set CST_SRAM_4WAIT , 		0x0000 	/* SRAM 4 wait */
.set CST_SRAM_3WAIT , 		0x0001 	/* 3 wait */
.set CST_SRAM_2WAIT , 		0x0002 	/* 2 wait */
.set CST_SRAM_8WAIT , 		0x0003 	/* 8 wait */
.set CST_ROM0_1ST_4WAIT , 	0x0000 	/* ROM0 1st 4 wait */
.set CST_ROM0_1ST_3WAIT , 	0x0004 	/* 3 wait */
.set CST_ROM0_1ST_2WAIT , 	0x0008 	/* 2 wait */
.set CST_ROM0_1ST_8WAIT , 	0x000c 	/* 8 wait */
.set CST_ROM0_2ND_2WAIT , 	0x0000 	/* 2nd 2 wait */
.set CST_ROM0_2ND_1WAIT , 	0x0010 	/* 1 wait */
.set CST_ROM1_1ST_4WAIT , 	0x0000 	/* ROM 1 1st 4 wait */
.set CST_ROM1_1ST_3WAIT , 	0x0020 	/* 3 wait */
.set CST_ROM1_1ST_2WAIT , 	0x0040 	/* 2 wait */
.set CST_ROM1_1ST_8WAIT , 	0x0060 	/* 8 wait */
.set CST_ROM1_2ND_4WAIT , 	0x0000 	/* 2nd 4 wait */
.set CST_ROM1_2ND_1WAIT , 	0x0080 	/* 1 wait */
.set CST_ROM2_1ST_4WAIT , 	0x0000 	/* ROM 2 1st 4 wait */
.set CST_ROM2_1ST_3WAIT , 	0x0100 	/* 3 wait */
.set CST_ROM2_1ST_2WAIT , 	0x0200 	/* 2 wait */
.set CST_ROM2_1ST_8WAIT , 	0x0300 	/* 8 wait */
.set CST_ROM2_2ND_8WAIT , 	0x0000 	/* 2nd 8 wait */
.set CST_ROM2_2ND_1WAIT , 	0x0400 	/* 1 wait */
.set CST_PHI_OUT_NONE , 	0x0000 	/* terminal output clock fixed Lo */
.set CST_PHI_OUT_4MCK , 	0x0800 	/* 4MHz */
.set CST_PHI_OUT_8MCK , 	0x1000 	/* 8MHz */
.set CST_PHI_OUT_16MCK , 	0x1800 	/* 16MHz */
.set CST_PREFETCH_ENABLE , 	0x4000 	/* Enable prefetch buffer */
.set CST_AGB , 			0x0000 	/* AGB Game Pak */
.set CST_CGB , 			0x8000 	/* CGB Game Pak */
