@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@* TRSIpack decruncher v0.5 by Mr.Spiv - for gcc * Algorithm2
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@ v0.1 - 4-Feb-2004  - Original release
@ v0.2 - 13-Feb-2004 - 700 bytes version
@ v0.3 - 14-Feb-2004 - 
@ v0.3 - 22-Feb-2003 -
@ v0.4 - 9-Mar-2003  - TRSI version..
@ v0.5 - 9-Mar-2003  - cut off remaining gp32 specific stuff..
@ v0.6 - 9-Mar-2003  - minor fixes to register saves..
@


		.equ	SIZE_PRETABLE,	(12 + 8*8 + 17*4)
		.equ	SIZE_DECTABLE,	(12 + 16*8 + 378*4)
		.equ	SIZE_STACK,		(2048-128)
		.equ	TRSI_EOF,0xffff

		@
		@


		.ARM
		.TEXT
		@.GLOBAL	decrunchTRSi
		.GLOBAL	decrunch2
		.section	.iwram,"x",%progbits

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@ Parameters:
@   r0 = ptr to crunched data   (must be 4 bytes aligned)
@   r1 = ptr to destination mem (must be 2 bytes aligned)
@
@ Returns:
@   all regs r0->r12 are preserved..
@
@ Note:
@   For the "TRSi" version..
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

decrunch2:
decrunchTRSi:
		stmdb	sp!,{r0-r12,lr}
		mov		r8,r0
		mov		r9,r1
memtransfer:
		ldmia	r8!,{r0-r2}

		@ r8-4 -> r12 = ptr to crunched data (ID already skipped)
		@ r9 = ptr to destination mem

		sub		sp,sp,#SIZE_STACK
		
blockLoop:
		sub		r12,r8,#4
		ldrh	r8,[r12],#2		@ compressed size of block
		add		r1,r8,#1
		@ r0 = compressed block size
		cmp		r1,#0x10000
		addeq	sp,sp,#SIZE_STACK
		ldmeqia	sp!,{r0-r12}	@ exit..
		ldmeqia	sp!,{r0}
		bxeq	r0


		@
		ldrh	r11,[r12],#2
		ldrh	r1,[r12],#2
		mov		r10,#16
		orr		r11,r1,r11,lsl #16
		add		r8,r12,r8

		@ r8 = (end of compressed block)+6
		@ r12 = b (r11 = _bb, r10 = _bc)
		@
		@ Build trees.. r2-r7 are free for use

decodeTrees:
		mov		r2,#3
		mov		r3,#16
		mov		r4,sp
		bl		prepareDecodingStructure

		@ read in depths

		mov		r5,#0
		ldr		r6,[r4]
0:		mov		r1,#3
		bl		getB
		orr		r1,r5,r0,lsl #16
		str		r1,[r6],#4
		add		r5,r5,#1
		cmp		r5,r3
		blo		0b

		@ build tree..
		@  r3 = num symbols = 16
		@  r4 = ptr to decoding structure..

		bl		buildDecodingTree	@ PRETREE

		@ decoding structure for real decoding huffman..

		mov		r2,#4
		mov		r3,#376				@ actually 377
		add		r3,r3,#1
		add		r4,sp,#SIZE_PRETABLE
		bl		prepareDecodingStructure

		@ decode actual decoding huffman depths.. using pretree

		mov		r5,#0
		ldr		r6,[r4]
1:		mov		r2,sp
		bl		getSyml
		orr		r0,r5,r2,lsl #16
		str		r0,[r6],#4
		add		r5,r5,#1
		cmp		r5,r3
		blo		1b

		@ build tree..
		@  r3 = num symbols = 377
		@  r4 = ptr to decoding structure..

		bl		buildDecodingTree	@ DECTREE

		@ r2  = decoding structure ptr..
		@ r8  = (end of compressed block)+6
		@ r9  = dest
		@ r0,r1,r7 are general trash registers (functions..)
		@ r10,r11,r12 are reserved for bit input
		@ 

		sub		r5,r3,#120		@ r5 -> 257 i.e. base for match huffman codes

mainLoop:
		add		r2,sp,#SIZE_PRETABLE
		bl		getSyml
		cmp		r2,#256
		beq		blockLoop
decodeLiteral:
		strlob	r2,[r9],#1
		blo		mainLoop
decodeMatch:
 		sub		r2,r2,r5
		ands	r1,r2,#7		@ r1 = length bits..
		mov		r3,#1
		add		r3,r3,r3,lsl r1
		blne	getB			@ get low length bits.. 
		addne	r3,r3,r0

		movs	r1,r2,lsr #3	@ r4 = offset bits..
		mov		r4,#1
		movne	r4,r4,lsl r1
		blne	getB			@ get low length bits.. 
		addne	r4,r4,r0

copyLoop:
		ldrb	r1,[r9,-r4]
		subs	r3,r3,#1
		strb	r1,[r9],#1
		bne		copyLoop
		b		mainLoop

@
@ Parameters:
@  r11 = cde
@  r1 = ??
@  r2 = ptr to tables..
@
@ Returns:
@  r0 = bits encoding the symbol..
@  r1 = cnt (num bits needed for symbol..)
@  r2 = symbol
@
@ Trashes:
@  r7
@

getSyml:
		ldr		r7,[r2],#4
0:		ldr		r1,[r2],#8
		cmp		r11,r1
		bhi		0b

		ldrh	r1,[r2,#-2]	@ cnt = _tbl->bts
		ldrh	r2,[r2,#-4]	@ _tbl->ind
		rsb		r0,r1,#32
		mov		r0,r11,lsr r0
		add		r0,r0,r2
		mov		r0,r0,lsl #16
		ldr		r2,[r7,r0,lsr #14]

@ 
@ r1 = number of input bits (1-16)
@ r0 = return value
@ r10 = bc
@ r11 = bb
@ r12 = membuffer
@
@ Trashes r0 & r1 & flags
@

getB:	rsb		r0,r1,#32
		subs	r10,r10,r1
		mov		r0,r11,lsr r0
		mov		r11,r11,lsl r1
		movgt	pc,lr
		@
		ldrh	r1,[r12],#2
		rsb		r10,r10,#0
		orr		r11,r11,r1,lsl r10
		rsbs	r10,r10,#16
		mov		pc,lr

@
@
@ Parameters:
@  r2 = numbits
@  r3 = num codes
@  r4 = dest..
@
@ Returns:
@  r0 = ptr to tables..
@


@ Add space for dectbl.. which is maximum 
@ 8 << numbits of bytes..
@
@ struct dectbl {
@   unsigned long cde;
@   unsigned short ind;
@   unsigned short bts;
@ };
@
@ Memory layout is as follows:
@
@   4  ptr_to_alp
@   n  dectbl[n]  
@   4  0x00000000
@   m  _alp[m]
@   4  (maxcodelength+1) << 16
@
@
@ Parameters:
@  r2 = numbits
@  r3 = num symbols
@  r4 = dest..
@

prepareDecodingStructure:
		stmdb	sp!,{r2-r4,lr}
		mov		r1,r4
		add		r4,r4,#4
  		mov		r0,#8
		add		r4,r4,r0,lsl r2

		@ Prepare for _alp..

		mov		r5,#0
		str		r5,[r4],#4
		str		r4,[r1]

		@ insert endmark to _alp..

		mov		r0,#1
		add		r0,r0,r0,lsl r2
		mov		r0,r0,lsl #16
		str		r0,[r4,r3,lsl #2]
		ldmia	sp!,{r2-r4,pc}


@
@ Parameters:
@  r3 = num symbols
@  r4 = dest..
@

buildDecodingTree:
		stmdb	sp!,{r4,lr}
		mov		r5,#0		@ i
		ldr		r2,[r4],#4

inplaceShellsort:
		ldr		r0,[r2,r5,lsl #2]	@ r0 = (i | (depth << 16)
		add		r6,r2,r5,lsl #2
0:		ldr		r1,[r6,#-4]!		@ r1 = (i | (depth << 16)
		cmp		r1,r0
		strhi	r1,[r6,#4]
		bhi		0b
		str		r0,[r6,#4]
		add		r5,r5,#1
		cmp		r5,r3
		blo		inplaceShellsort

		@ Find _start.. i.e. find the first symbol with
		@ nonzero weight.
		@
		@ r2 = start of symbols

		mov		r5,#0
2:		cmp		r5,r3
		bhs		calculateCanonicalCodes
		ldr		r1,[r2,r5,lsl #2]		@ could do lsl #2 :)
		movs	r1,r1,lsr #16
		addeq	r5,r5,#1
		beq		2b

calculateCanonicalCodes:

		add		r6,r2,r5,lsl #2
		mov		r2,#0
		mvn		r7,#0

		@ r4 = _tlb
		@ r3 = _alpsize
		@ r2 = c = 0
		@ r5 = n
		@ r6 = _alp+_start
		@ r7 = 0xffffffff

0:		ldrh	r0,[r6,#2]
		ldrh	r1,[r6,#6]
		subs	r1,r1,r0	@ if (r0 < r1) ??
		ble		1f

		mov		lr,r7,lsr r0
		orr		lr,lr,r2, ror r0	
		str		lr,[r4],#4	@ cde
		sub		lr,r5,r2	@ ind = (unsigned short)(n-c)
		strh	lr,[r4],#2	@ ind
		strh	r0,[r4],#2	@ bts

1:		add		r2,r2,#1
		movgt	r2,r2,lsl r1
		add		r5,r5,#1
		ldr		r0,[r6],#4
		cmp		r5,r3			@ for ( ; n < _alpsize; n++)..
		and		r0,r0,r7,lsr #16
		str		r0,[r6,#-4]
		blo		0b
		ldmia	sp!,{r4,pc}


		.END
	
