@
@
@
@
		.text
		.arm


		.global		InterruptProcess
		.global		bgcopper

		.section	.iwram,"ax",%progbits


		
		.include	"agbdefine.i"
		.include	"agbmemorymap.i"
		.include	"afm.i"
		
InterruptProcess:
		ldr		r3,=REG_IE
		ldr		r2,[r3]
		and		r1,r2,r2,lsr #16
                @
		ands	r0,r1,#H_BLANK_INTR_FLAG
		ldrne	r2,=hblankIRQ
		bne		jump_intr
		ands	r0,r1,#V_BLANK_INTR_FLAG
		ldrne	r2,=vblankIRQ
		bne		jump_intr
		ands	r0,r1,#V_COUNT_INTR_FLAG
		ldr		r2,=vcountIRQ
jump_intr:
		strh	r0,[r3,#2]
		bx		r2
		

vcountIRQ:
		stmdb	sp!,{r4-r12,lr}
		ldr		r0,=vcwait
		ldrh	r1,[r0]
		add		r1,r1,#1
		strh	r1,[r0]
		bl		bgcopper
		@bl		afm_update
		ldmia	sp!,{r4-r12,pc}


vblankIRQ:
		stmdb   sp!,{r4-r11,lr}
		@ stop hblank dma
		ldr		r0,=REG_DMA0SAD
		mov		r1,#0
		strh	r1,[r0,#REG_DMA0CNT_H-REG_DMA0SAD]

		@
		@bl		afm_sync
		ldr		r0,=afm_sync
		mov		lr,pc
		bx		r0

		ldr		r0,=vbwait
		ldrh	r1,[r0]
		add		r1,r1,#1
		strh	r1,[r0]
		@
		ldmia   sp!,{r4-r11,pc}

hblankIRQ:
		stmdb   sp!,{r4-r11,lr}
		ldr		r0,=menuon		
		ldrh	r0,[r0]
		cmp		r0,#2
		ldmltia  sp!,{r4-r11,pc}

		@ do the raster stuff..
		ldr		r0,=REG_BLDCNT
		mov		r1,#REG_BASE
		add		r1,r1,#OFFSET_REG_VCOUNT
		mov		r2,#BLD_UP_MODE|BLD_BG1_1ST
		mov		r3,#BLD_DOWN_MODE|BLD_BG1_1ST
		mov		r4,#16

		@
		@ r0 = BLDCNT
		@ r1 = VCOUNT
		@ r2 =
		@ r3 =
		@ r4
		@
		@ check for raster positions..

		ldrh	r5,[r1]
		cmp		r5,#1
		streqh	r3,[r0]
		streqh	r4,[r0,#4]
		cmp		r5,#56
		moveq	r4,#11
		streqh	r4,[r0,#4]
		cmp		r5,#64
		moveq	r4,#5
		streqh	r4,[r0,#4]
		cmp		r5,#74
		streqh	r2,[r0]
		moveq	r4,#0
		streqh	r4,[r0,#4]

		cmp		r5,#96
		ldreq	r4,=bldfade
		ldrh	r4,[r4]
		streqh	r4,[r0,#4]

		cmp		r5,#104
		moveq	r4,#0
		streqh	r4,[r0,#4]
		cmp		r5,#128
		streqh	r3,[r0]
		moveq	r4,#5
		streqh	r4,[r0,#4]
		cmp		r5,#136
		moveq	r4,#11
		streqh	r4,[r0,#4]
		cmp		r5,#144
		moveq	r4,#16
		streqh	r4,[r0,#4]

		ldmia   sp!,{r4-r11,pc}





@
@ Setup DMA to change the background color..
@ Use DMA3 as it can access the ROM area.
@
@



bgcopper:
		ldr		r3,=REG_DMA0SAD
		ldr		r1,=REG_BG0HOFS
		mov		r0,#0
		strh	r0,[r3,#REG_DMA0CNT_H-REG_DMA0SAD]

		ldr		r4,=menuon		
		ldrh	r4,[r4]
		cmp		r4,#0
		beq		1f

		@
		ldr		r2,=bg1xpos
		str		r0,[r1],#4
		ldrh	r3,[r2],#2	@ bg1xpos
		strh	r3,[r1],#2
		ldrh	r3,[r2],#2	@ bg1ypos
		strh	r3,[r1],#2
		mov		pc,lr

1:		ldr		r0,=xypos
		ldr		r2,=(DMA_ENABLE|DMA_CONTINUOUS_ON|DMA_DEST_RELOAD|DMA_SRC_INC|DMA_TIMMING_H_BLANK|4)
		stmia	r3,{r0-r2}
		mov		pc,lr

@
@
@
@

		.pool
		
		


		.section	.iwram,"ax",%progbits
		.global		xypos
		.global		copper



xypos:
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,0,0,0
	.short	0,3,441,7
	.short	507,4,446,8
	.short	505,12,448,16
	.short	504,14,449,18
	.short	502,16,451,20
	.short	501,18,452,22
	.short	500,19,453,23
	.short	499,20,454,24
	.short	498,21,455,25
	.short	497,21,456,25
	.short	496,22,457,26
	.short	495,23,458,27
	.short	494,23,459,27
	.short	493,23,460,27
	.short	493,24,460,28
	.short	492,24,461,28
	.short	491,24,462,28
	.short	491,25,462,29
	.short	490,25,463,29
	.short	489,25,464,29
	.short	488,25,464,29
	.short	488,26,465,30
	.short	487,26,466,30
	.short	487,26,466,30
	.short	486,26,467,30
	.short	485,26,468,30
	.short	485,26,468,30
	.short	484,26,469,30
	.short	483,26,470,30
	.short	483,26,470,30
	.short	482,26,471,30
	.short	482,26,471,30
	.short	481,26,472,30
	.short	481,26,472,30
	.short	480,26,473,30
	.short	479,26,474,30
	.short	479,26,474,30
	.short	478,26,475,30
	.short	478,26,475,30
	.short	477,26,476,30
	.short	476,26,477,30
	.short	475,26,478,30
	.short	475,26,478,30
	.short	474,26,479,30
	.short	474,26,479,30
	.short	473,26,480,30
	.short	472,26,481,30
	.short	472,26,481,30
	.short	471,26,482,30
	.short	471,26,482,30
	.short	470,26,483,30
	.short	470,26,483,30
	.short	469,26,484,30
	.short	468,26,485,30
	.short	468,26,485,30
	.short	467,26,486,30
	.short	466,26,487,30
	.short	466,26,487,30
	.short	465,26,488,30
	.short	464,26,488,30
	.short	464,26,489,30
	.short	463,26,490,30
	.short	462,27,491,31
	.short	462,27,491,31
	.short	461,27,492,31
	.short	460,27,493,31
	.short	460,28,493,32
	.short	459,28,494,32
	.short	458,28,495,32
	.short	457,29,496,33
	.short	456,29,497,33
	.short	455,29,498,33
	.short	454,30,499,34
	.short	453,31,500,35
	.short	452,31,501,35
	.short	451,32,502,36
	.short	449,33,504,37
	.short	448,34,505,38
	.short	446,36,507,40
	.short	441,38,0,42
	.short	0,53,0,53
	.short	0,54,0,54
	.short	0,55,0,55
	.short	0,56,0,56
	.short	0,57,0,57
	.short	0,58,0,58
	.short	0,59,0,59
	.short	0,60,0,60
	.short	0,0,0,0



