//
//
//
//
//



#include "agbdefine.h"
#include "afm.h"
#include "agbmemorymap.h"
//#include "decrunch.h"

#include "intro.h"
#include "options.h"

//
// A lot of defines..
//

#define serp_font_start		0x2000000
#define serp_font_gfx		(serp_font_start + 512)
#define mod_start			(serp_font_start+19328)
#define tiny_font_start		(mod_start+16728)
#define sintable			(tiny_font_start+3072)
#define trash_start			(sintable+2048)

#define SP	144			// empty tile..
#define NUMFNTSPR	9
#define TINYTILESTART	0x288


// screen defines..

#define bg0_chars		VRAM
#define bg1_chars		(bg0_chars+32*32*2)
#define bg2_chars		(bg1_chars+32*32*2)
#define bg_char_data	(VRAM+0x4000)
#define	logo_start		bg_char_data
#define serp0_start		(logo_start+0x2a00)
#define serp1_start		(serp0_start+0x1380)
#define small_char_data	(serp1_start+0x1380)

//
//
//

struct menuLine {
	char *str;
	int (*func)( void );
};




//
//
//


static void initSerpBG( unsigned short *, unsigned short *, int );
void irq_handler( void );
static int scroll(unsigned short *tiles, unsigned char *txt, unsigned short *gfx, int pos, int *, int );
int spriteScroll( unsigned char *txt, int pos );
static void initSprites( unsigned short *gfx, int num );

//
//
//



extern unsigned char _binary_fonts_24x32_tiled_pak_start[];
extern unsigned char _binary_dbs_mod_pak_start[];
extern unsigned char _binary_trsi_192x56_tiled_pak_start[];
extern unsigned char _binary_my8x8font_pak_start[];
extern unsigned char _binary_sin_pak_start[];

extern IN_WRAM int decrunch2( void *, void * );



const unsigned short fontMap[];
const unsigned char text1[];
const unsigned char text2[];
const unsigned char text3[];
const unsigned short serpMap0[];
const unsigned short serpMap1[];
const unsigned char menuFontMap[];
const unsigned char bldTable[] ;

volatile short	vbwait = 0;
volatile short	vcwait = 0;
volatile short	menuon = 0;
volatile short	menucnt = -1;
volatile unsigned short bg1xpos = 0;
volatile unsigned short bg1ypos = 0;
volatile unsigned short bldfade;

static short Yold = 80;
static short Ynew = 80;
static short Zold = 40;
static short Znew = 40;
static short Sold = 24;
static short Snew = 24;
static short spos = 0;
static short speed1 = 1;
static short speed2 = 2;


//
// Max 32 of these..
//

struct trainerEntry trainerList[32] = {
	{0,textline0},		// 0
	{0,textline1},		// 1
	{0,textline2},		// 2
	{0,textline3},		// 3
	{0,dashes},		// 4
	{0,count5},	// 5
	{0,onOff6},		// 6
	{0,onOff7},		// 7
	{0,onOff8},		// 8
	{0,onOff9},		// 9
	{0,count10},		// 10
	{0,count11},		// 11
	{0,onOff12},		// 12
	{0,onOff13},		// 13
	{0,onOff14},		// 14
	{0,onOff15},		// 15
	{0,dashes},		// 16
	{0,exitMenu},		// 17
	{0,0},		// 18
	{0,0},		// 19
	{0,0},		// 20
	{0,0},		// 21
	{0,0},		// 22
	{0,0},		// 23
	{0,0},		// 24
	{0,0},		// 25
	{0,0},		// 26
	{0,0},		// 27
	{0,0},		// 28
	{0,0},		// 29
	{0,0},		// 30
	{0,0}		// 31
};

#define NUMTRAINERENTRIES sizeof(trainerList);

//
//
//

void startTrainerPhase( void ) {
	if (menucnt < 0) {
		//menucnt = 208;
		menucnt = 116;
		//speed1 = 2;
		speed1 = 4;
		speed2 = 4;
	}
}

//
//
//

void doFlash( void ) {
	static int step = 0;
	bldfade = bldTable[step++];
	step &= 63;
}


//
//
//

void waitline(unsigned long line){
	while (rREG_VCOUNT != line);
}



//
// len in shorts..
//

//static void dma0Copy( void *d, void *s, int len ) {
//	rREG_DMA0SAD = (long)s;
//	rREG_DMA0DAD = (long)d;
//	rREG_DMA0CNT = DMA_ENABLE|len;
//}

static void dma2Copy( void *d, void *s, int len ) {
	rREG_DMA2SAD = (long)s;
	rREG_DMA2DAD = (long)d;
	rREG_DMA2CNT = DMA_ENABLE|len;
}

//
//
//

static void moveLogo( unsigned short *bg, unsigned short empty) {
	unsigned short w;
	unsigned short c;
	int m,n;

	w = empty;
	w <<= 8;
	w |= empty;

	for (n = 0; n < 32*32/2; n++) {
		bg[n] = w;
	}

	//bg = bg + 16 + 2;
	bg = bg + 16 +1;
	c = 0;

	for (m = 0, c = 0; m < 7; m++) {
		for (n = 0; n < 12; n++) {
			w = c+1; w <<= 8; w |= c;
			c += 2;
			*bg++ = w;
		}
		bg += 4;
	}
}

//
//
//
//
//
//

void AgbMain( void ) {
	short *pal = (short *)PLTT;
	int n,m,s;
	int cnt0, cnt1;
	int y;
	unsigned short nkey, okey;
	int done;


	decrunch2(_binary_fonts_24x32_tiled_pak_start,(void *)serp_font_start);
	decrunch2(_binary_dbs_mod_pak_start,(void *)mod_start);
	decrunch2(_binary_my8x8font_pak_start,(void *)trash_start);
	dma2Copy((void *)small_char_data,(void*)(trash_start+512),2048/2);
	decrunch2(_binary_sin_pak_start,(void *)sintable);
	decrunch2(_binary_trsi_192x56_tiled_pak_start,(void *)trash_start);
	
	// setup small fonts..

	// setup logo palette.. 92 colors..
	dma2Copy(pal,(void*)trash_start,256);

	// setup palette.. sprites..
	dma2Copy((void*)OBJ_PLTT,(void*)(trash_start+12*32),16);	// serp0


	// fix logo tile gfx
	dma2Copy((void*)logo_start,(void*)(trash_start+512),24*7*64/2);

	// setup logo..
	moveLogo((unsigned short *)bg2_chars,SP);

	//
	//
	//

	initSerpBG((unsigned short*)bg0_chars,serpMap0,SP);
	initSerpBG((unsigned short*)bg1_chars,serpMap1,SP);
	
	// Init sprites
	
	initSprites((unsigned short *)serp_font_gfx,49);
	
	//
	// init interrupts..

	rREG_STAT= STAT_V_BLANK_IF_ENABLE|STAT_H_BLANK_IF_ENABLE|
				STAT_V_COUNT_IF_ENABLE|(219 << 8);	// enable vblank, vcount@30
	rREG_IE  = V_BLANK_INTR_FLAG|H_BLANK_INTR_FLAG|V_COUNT_INTR_FLAG;	// enable vblank, vcount
	rREG_IF  = V_BLANK_INTR_FLAG|H_BLANK_INTR_FLAG|V_COUNT_INTR_FLAG;	// enable vblank, vcount
	rREG_IME |= 1;									// master enable

	// set screen mode
	
	rREG_BG0CNT =	BG_PRIORITY_1|BG_COLOR_16|BG_SCREEN_SIZE_0|
					(1 << BG_CHAR_BASE_SHIFT)|(0 << BG_SCREEN_BASE_SHIFT);
	rREG_BG1CNT =	BG_PRIORITY_2|BG_COLOR_16|BG_SCREEN_SIZE_0|
					(1 << BG_CHAR_BASE_SHIFT)|(1 << BG_SCREEN_BASE_SHIFT);
	rREG_BG2CNT =	BG_PRIORITY_0|BG_COLOR_256|BG_SCREEN_SIZE_1|BG_MOS_ON|
					(1 << BG_CHAR_BASE_SHIFT)|(2 << BG_SCREEN_BASE_SHIFT);
	rREG_DISPCNT = 	DISP_BG0_ON|DISP_BG1_ON|DISP_BG2_ON|DISP_OBJ_ON|DISP_OBJ_CHAR_1D_MAP|
					DISP_MODE_1;
	rREG_BLDCNT = 0;
	rREG_BG0HOFS = 0;
	rREG_BG0VOFS = 0;
	rREG_BG1HOFS = 0;
	rREG_BG1VOFS = 0;
	
	// mod stuff..
	
	afm_install();
	//*****afm_init((unsigned char *)_binary_dbs_mod_raw_start);
	afm_init((unsigned char *)mod_start);
	afm_sound_param(31,1);

	//


	n = 0;
	m = 0;
	s = 0;
	cnt0 = 0;
	cnt1 = 0;
	nkey = 0;
	okey = 0;
	y = 0;
	done = 0;

	while (!done) {
		while (vbwait == 0);
		//waitline(40);
		//*pal = vcwait;
		afm_update();
		vbwait = 0;
		//waitline(160);
		//afm_sync();

		//while (vbwait == 0);
		//vbwait = 0;
		//*pal = 0xf00;
		s = spriteScroll(text3,s);
		//*pal = 0xfff;

		nkey = (rREG_KEYINPUT ^ 0xffff) & ALL_KEY_MASK;

		if (nkey & ALL_KEY_MASK) {
			startTrainerPhase();
		}
		if (menuon == 1) {
			y = menuInit( (unsigned short *)bg1_chars, trainerList );
			bg1ypos = ((y << 3) - 96) & 511;
			menuon = 2;
		}
		if (menuon == 0) {
			n = scroll((unsigned short*)serp0_start,text1,(unsigned short*)serp_font_gfx,n,&cnt0,speed1);
			m = scroll((unsigned short*)serp1_start,text2,(unsigned short*)serp_font_gfx,m,&cnt1,speed2);
		}
		if (menuon == 2) {
			// check keys..

			doFlash();

			if (nkey != okey) {
				if (nkey & U_KEY) {
					if (trainerList[(y-1) & 31].toggleFunc) {
						y--;
					}
				}
				if (nkey & D_KEY) {
					if (trainerList[(y+1) & 31].toggleFunc) {
						y++;
					}
				}
				if (nkey & BUTTON_MASK) {
					done = menuEvent( nkey & BUTTON_MASK,(unsigned short *)(bg1_chars + (y<<6)), &trainerList[y]);
				}
				okey = nkey;
				bg1ypos = ((y << 3) - 96) & 511;
			}
		}
	}

	rREG_IME &= ~1;			// disable master enable
	afm_deinit();
	rREG_DISPCNT = 	0;


}

//
//
//

static void initSerpBG( unsigned short *bg, unsigned short *tiles, int empty ) {
	int n = 0;

	while (n++ < 9*32) {
		*bg++ = empty;
	}
	while (n++ < 25*32) {
		*bg++ = *tiles++;
	}
	while (n++ < 32*32) {
		*bg++ = empty;
	}
}

//
//
//

static void cpuCopy( unsigned short *d, unsigned short *s, int len ) {
	while (len-- > 0) {
		*d++ = *s++;
	}
}

static void cpuCopyL( unsigned long *d, unsigned long *s, int len ) {
	len >>= 2;
	while (len-- > 0) {
		*d++ = *s++;
		*d++ = *s++;
		*d++ = *s++;
		*d++ = *s++;
	}
}



//
//
//

static int scroll(unsigned short *tiles, unsigned char *txt, unsigned short *gfx, int pos, int *cnt, int speed ) {
	unsigned short w;
	unsigned short *s, *d;
	
	int n;

	//                                                                                                                                                                                                                                                                                                                   
	// dma might be reserved.. so cpu loop..

	*cnt -= speed;

	d = tiles;
	s = tiles + (speed << 1);

	cpuCopyL((unsigned long *)d,(unsigned long *)s,0x9c*16/2);

	//
	
	if (*cnt < 0) {
		d = tiles;
		d += *cnt*speed*2;

		if (menucnt > 0) {
			w = fontMap[' '-32];
		} else {
			w = fontMap[txt[pos++]-32];
		}
		s = (unsigned short*)(serp_font_gfx + w);

		for (n = 0; n < 4; n++) {
			cpuCopy(d+(0x30*16),s+0,16);
			cpuCopy(d+(0x64*16),s+16,16);
			cpuCopy(d+(0x98*16),s+32,16);
			d += 16;
			s += 48;
		}

		if (txt[pos] == 0) { pos = 0; }



		*cnt += 32;
	}

	return pos;
}

//
//
//


static void initSprites( unsigned short *gfx, int num ) {
	unsigned short *obj;
	unsigned long *oam;
	int m,n;
	int x,y;
	
	obj = (unsigned short *)OBJ_MODE1_VRAM;
	x = 0;
	y = 72+40-32;

	// move gfx

	while (num-- > 0) {
		for (n = 0; n < 4; n++) {
			// move 3 tiles.. 16 colors.. 1 dimensional..
			for (m = 0; m < 3*4*8/2; m++) {
				*obj++ = *gfx++;
			}
			// 1 clear tile..
			for (m = 0; m < 4*8/2; m++) {
				*obj++ = 0;
			}
		}
	}

	// Fix OAM for scroller sprites.. 9 of them

	oam = (unsigned long *)OAM;
	//n = fontMap[0] / 24;
	n = 416;

	for (m = 0; m < NUMFNTSPR; m++) {
		*oam++ = (OAM_MOS_OFF|OAM_SIZE_32x32|OAM_AFFINE_TWICE|OAM_COLOR_16|y|((x & 0x1ff)<<16));
		*oam++ = (2<<OAM_PRIORITY_SHIFT|n);
		x += 32;
		//n += 16;
	}

	// disable rest
	for (; m < 128; m++) {
		*oam++ = OAM_AFFINE_ERASE;
		*oam++ = 0;
	}

	// Fix scaling
	
	obj = (unsigned short *)OAM;
	obj[3] = 0x00c0;
	obj[7] = 0x0000;
	obj[11] = 0x0000;
	//obj[15] = 0x00c0;
	obj[15] = 0x0155;
}

//
//
//

int spriteScroll( unsigned char *txt, int pos ) {
	static short speed = 2;
	static short scrollcount = 0;
	static short pause = 0;
	static short Yindex = 0;
	static short xpos = 40;
	int sss;

	short *sinTbl = (short *)sintable;
	int y, n, mx, f;
	short *oam;
	short x;
	
	if (menucnt > 0) { menucnt--; }
	if (menucnt == 40) {
		Znew = 12;
		Ynew = 116;
		Snew = 0;
	}
	if ((menucnt == 0) && (menuon == 0)) {
		menuon = 1;
	}
	
	//
	
	oam = (short *)OAM;

	// scaling..

	y = (32 << 8) / Zold;
	oam[15] = y;

	// Check for a new font..
	
	mx = Yindex << 2;
	xpos -= speed;

	if (xpos < 0) {
		xpos += 32;
		x = oam[mx + 1] & 0x1ff;
		x += NUMFNTSPR*32;
		oam[mx + 1] = (oam[mx + 1] & ~0x1ff) | (x & 0x1ff);

		while (((f = txt[pos++]) < ' ') || (f >= 'a') ) {
			switch (f) {
			case 0:
				pos = 0;
				break;
			case 'm':
				startTrainerPhase();
				break;
			case 's':
				Snew  = (txt[pos++] - 'a') << 4;
				Snew |= (txt[pos++] - 'a');
				break;
			case 'c':
				speed = (txt[pos++] - 'a') + 1;
				break;
			default:
				break;
			}
		}

		f = fontMap[f -32] / 24;
		oam[mx + 2] = (oam[mx + 2] & ~0x3ff) | f;

		if (++Yindex >= NUMFNTSPR) {
			spos = spos + Yindex * 80;
			Yindex = 0;
		}
	}
	
	// scroll all..

	mx = Yindex << 2;
	sss = spos + Yindex * 80;
	
	for (n = 0; n < NUMFNTSPR; n++) {
		x = (oam[mx + 1] & 0x1ff) - speed;

		y = Yold + ((sinTbl[sss & 0x3ff] * Sold) >> 8);
		oam[mx + 0] = (oam[mx + 0] & ~0x0ff) | (y & 0x0ff);
		oam[mx + 1] = (oam[mx + 1] & ~0x1ff) | (x & 0x1ff);
		mx += 4;
		if (mx >= NUMFNTSPR*4) { mx = 0; }
		sss += 80;
	}

	spos = (spos + 15) & 0x3ff;

	if (Yold < Ynew) {
		Yold++;
	} if (Yold > Ynew) {
		Yold--;
	}
	if (Zold < Znew) {
		Zold++;
	} if (Zold > Znew) {
		Zold--;
	}
	if (Sold < Snew) {
		Sold++;
	} if (Sold > Snew) {
		Sold--;
	}


	return pos;
}

//
//
//

void printLine( int x, unsigned short *scr, char *str ) {
	unsigned short w;
	scr += x;

	while (*str) {
		w = (menuFontMap[*str++ - 32] + TINYTILESTART) | 0xd000;
		*scr++ = w;
	}
}


//
//
//

int menuInit( unsigned short *scr, struct trainerEntry *lst ) {
	char *empty = "                               ";
	int y, n;

	for (y = 0; y < 32; y++) {
		printLine(0,scr,empty);
	}
	for (y = 0, n = -1; y < 32; y++) {
		int (*func)( int, unsigned short *, void (*)(int, unsigned short *,char *) ) = lst[y].toggleFunc;

		if (func) {
			if (n < 0) { n = y; }
			lst[y].ctrl = func(TOGGLE_NONE,scr+(y<<5),printLine);
		}
	}
	return n;
}

//
//
//

int menuEvent( int key, unsigned short *scr, struct trainerEntry *lst ) {
	return lst->toggleFunc(key,scr,printLine);
}




//
// tilemaps..
//



RODATA const unsigned short serpMap0[] = {
0x8150,0x8184,0x81b8, SP,SP,SP,SP,SP,SP,SP,0xa1fc,0xa230,0xa264, SP,SP,SP,SP,SP,SP,SP,0x8170,0x81a4,0x81d8, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0x8151,0x8185,0x81b9, SP,SP,SP,SP,SP,SP,SP,0xa1fd,0xa231,0xa265, SP,SP,SP,SP,SP,SP,SP,0x8171,0x81a5,0x81d9, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0x8152,0x8186,0x81ba, SP,SP,SP,SP,SP,SP,SP,0xa1fe,0xa232,0xa266, SP,SP,SP,SP,SP,SP,SP,0x8172,0x81a6,0x81da, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0x8153,0x8187,0x81bb, SP,SP,SP,SP,SP,SP,SP,0xa1ff,0xa233,0xa267, SP,SP,SP,SP,SP,SP,SP,0x8173,0x81a7,0x81db, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0x8154,0x8188,0x81bc, SP,SP,SP,SP,SP,SP,SP,0xa200,0xa234,0xa268, SP,SP,SP,SP,SP,SP,SP,0x8174,0x81a8,0x81dc, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0x8155,0x8189,0x81bd, SP,SP,SP,SP,SP,SP,SP,0xa201,0xa235,0xa269, SP,SP,SP,SP,SP,SP,SP,0x8175,0x81a9,0x81dd, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0x8156,0x818a,0x81be, SP,SP,SP,SP,SP,SP,SP,0xa202,0xa236,0xa26a, SP,SP,SP,SP,SP,SP,SP,0x8176,0x81aa,0x81de, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0x8157,0x818b,0x81bf, SP,SP,SP,SP,SP,SP,SP,0xa203,0xa237,0xa26b, SP,SP,SP,SP,SP,SP,SP,0x8177,0x81ab,0x81df, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0x8158,0x818c,0x81c0, SP,SP,SP,SP,SP,SP,SP,0xa204,0xa238,0xa26c, SP,SP,SP,SP,SP,SP,SP,0x8178,0x81ac,0x81e0, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0x8159,0x818d,0x81c1, SP,SP,SP,SP,SP,SP,SP,0xa205,0xa239,0xa26d, SP,SP,SP,SP,SP,SP,SP,0x8179,0x81ad,0x81e1, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0x815a,0x818e,0x81c2, SP,SP,SP,SP,SP,SP,SP,0xa206,0xa23a,0xa26e, SP,SP,SP,SP,SP,SP,SP,0x817a,0x81ae,0x81e2, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0x815b,0x818f,0x81c3, SP,SP,SP,SP,SP,SP,SP,0xa207,0xa23b,0xa26f, SP,SP,SP,SP,SP,SP,SP,0x817b,0x81af,0x81e3, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0x815c,0x8190,0x81c4, SP,SP,SP,SP,SP,SP,SP,0xa208,0xa23c,0xa270, SP,SP,SP,SP,SP,SP,SP,0x817c,0x81b0,0x81e4, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0x815d,0x8191,0x81c5, SP,SP,SP,SP,SP,SP,SP,0xa209,0xa23d,0xa271, SP,SP,SP,SP,SP,SP,SP,0x817d,0x81b1,0x81e5, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0x815e,0x8192,0x81c6, SP,SP,SP,SP,SP,SP,SP,0xa20a,0xa23e,0xa272, SP,SP,SP,SP,SP,SP,SP,0x817e,0x81b2,0x81e6, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0x815f,0x8193,0x81c7, SP,SP,SP,SP,SP,SP,SP,0xa20b,0xa23f,0xa273, SP,SP,SP,SP,SP,SP,SP,0x817f,0x81b3,0x81e7, SP,SP,SP,SP,SP,SP,SP,SP,SP
	// x180-x183	newfont col0
	// x1b4-x1b7	newfont col1
	// x1e8-x1eb	newfont col1

};

RODATA const unsigned short serpMap1[] = {

0xb9fb,0xba2f,0xba63, SP,SP,SP,SP,SP,SP,SP,0x996f,0x99a3,0x99d7, SP,SP,SP,SP,SP,SP,SP,0xba1b,0xba4f,0xba83, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0xb9fa,0xba2e,0xba62, SP,SP,SP,SP,SP,SP,SP,0x996e,0x99a2,0x99d6, SP,SP,SP,SP,SP,SP,SP,0xba1a,0xba4e,0xba82, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0xb9f9,0xba2d,0xba61, SP,SP,SP,SP,SP,SP,SP,0x996d,0x99a1,0x99d5, SP,SP,SP,SP,SP,SP,SP,0xba19,0xba4d,0xba81, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0xb9f8,0xba2c,0xba60, SP,SP,SP,SP,SP,SP,SP,0x996c,0x99a0,0x99d4, SP,SP,SP,SP,SP,SP,SP,0xba18,0xba4c,0xba80, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0xb9f7,0xba2b,0xba5f, SP,SP,SP,SP,SP,SP,SP,0x996b,0x999f,0x99d3, SP,SP,SP,SP,SP,SP,SP,0xba17,0xba4b,0xba7f, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0xb9f6,0xba2a,0xba5e, SP,SP,SP,SP,SP,SP,SP,0x996a,0x999e,0x99d2, SP,SP,SP,SP,SP,SP,SP,0xba16,0xba4a,0xba7e, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0xb9f5,0xba29,0xba5d, SP,SP,SP,SP,SP,SP,SP,0x9969,0x999d,0x99d1, SP,SP,SP,SP,SP,SP,SP,0xba15,0xba49,0xba7d, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0xb9f4,0xba28,0xba5c, SP,SP,SP,SP,SP,SP,SP,0x9968,0x999c,0x99d0, SP,SP,SP,SP,SP,SP,SP,0xba14,0xba48,0xba7c, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0xb9f3,0xba27,0xba5b, SP,SP,SP,SP,SP,SP,SP,0x9967,0x999b,0x99cf, SP,SP,SP,SP,SP,SP,SP,0xba13,0xba47,0xba7b, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0xb9f2,0xba26,0xba5a, SP,SP,SP,SP,SP,SP,SP,0x9966,0x999a,0x99ce, SP,SP,SP,SP,SP,SP,SP,0xba12,0xba46,0xba7a, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0xb9f1,0xba25,0xba59, SP,SP,SP,SP,SP,SP,SP,0x9965,0x9999,0x99cd, SP,SP,SP,SP,SP,SP,SP,0xba11,0xba45,0xba79, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0xb9f0,0xba24,0xba58, SP,SP,SP,SP,SP,SP,SP,0x9964,0x9998,0x99cc, SP,SP,SP,SP,SP,SP,SP,0xba10,0xba44,0xba78, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0xb9ef,0xba23,0xba57, SP,SP,SP,SP,SP,SP,SP,0x9963,0x9997,0x99cb, SP,SP,SP,SP,SP,SP,SP,0xba0f,0xba43,0xba77, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0xb9ee,0xba22,0xba56, SP,SP,SP,SP,SP,SP,SP,0x9962,0x9996,0x99ca, SP,SP,SP,SP,SP,SP,SP,0xba0e,0xba42,0xba76, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0xb9ed,0xba21,0xba55, SP,SP,SP,SP,SP,SP,SP,0x9961,0x9995,0x99c9, SP,SP,SP,SP,SP,SP,SP,0xba0d,0xba41,0xba75, SP,SP,SP,SP,SP,SP,SP,SP,SP,
0xb9ec,0xba20,0xba54, SP,SP,SP,SP,SP,SP,SP,0x9960,0x9994,0x99c8, SP,SP,SP,SP,SP,SP,SP,0xba0c,0xba40,0xba74, SP,SP,SP,SP,SP,SP,SP,SP,SP,



	// x21c-x21f	newfont col0
	// x250-x253	newfont col1
	// x284-x287	newfont col1

};

//
//
//

RODATA const unsigned char bldTable[] = {
	0x00,0x00,0x01,0x02,0x03,0x03,0x04,0x05,
	0x06,0x06,0x07,0x08,0x08,0x09,0x0a,0x0a,
	0x0b,0x0b,0x0c,0x0c,0x0d,0x0d,0x0e,0x0e,
	0x0e,0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,
	0x10,0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,
	0x0e,0x0e,0x0e,0x0d,0x0d,0x0c,0x0c,0x0b,
	0x0b,0x0a,0x0a,0x09,0x08,0x08,0x07,0x06,
	0x06,0x05,0x04,0x03,0x03,0x02,0x01,0x00
};


//
//
//
// Starts form the space..
//

RODATA const unsigned short fontMap[] = {
	384*26,			// ' ' 
	384*37,			//	!
	384*47,			//	"
	384*26,			//	#
	384*26,			//	$
	384*26,			//	%
	384*26,			//	&
	384*46,			//	'
	384*42,			//	(
	384*43,			//	)
	384*44,			//	*
	384*44,			//	+
	384*45,			//	,
	384*41,			//	-
	384*38,			//	.
	384*48,			//	/
	384*27,			//	0
	384*28,			//	1
	384*29,			//	2
	384*30,			//	3
	384*31,			//	4
	384*32,			//	5
	384*33,			//	6
	384*34,			//	7
	384*35,			//	8
	384*36,			//	9
	384*40,			//	:
	384*40,			//	;
	384*26,			//	<
	384*26,			//	=
	384*26,			//	>
	384*39,			//	?
	384*26,			//	@
	384*0,			//	A
	384*1,			//	B
	384*2,			//	C
	384*3,			//	D
	384*4,			//	E
	384*5,			//	F
	384*6,			//	G
	384*7,			//	H
	384*8,			//	I
	384*9,			//	J
	384*10,			//	K
	384*11,			//	L
	384*12,			//	M	
	384*13,			//	N
	384*14,			//	O
	384*15,			//	P
	384*16,			//	Q
	384*17,			//	R
	384*18,			//	S
	384*19,			//	T
	384*20,			//	U
	384*21,			//	V
	384*22,			//	W
	384*23,			//	X
	384*24,			//	Y
	384*25,			//	Z
	384*42,			//	[
	384*48,			//	\
	384*43,			//	]
	384*26,			//	^
	384*26,			//	_
	384*46,			//	`
	384*46,			//	`
	384*0,			//	a
	384*1,			//	b
	384*2,			//	c
	384*3,			//	d
	384*4,			//	e
	384*5,			//	f
	384*6,			//	g
	384*7,			//	h
	384*8,			//	i
	384*9,			//	j
	384*10,			//	k
	384*11,			//	l
	384*12,			//	m
	384*13,			//	n
	384*14,			//	o
	384*15,			//	p
	384*16,			//	q
	384*17,			//	r
	384*18,			//	s
	384*19,			//	t
	384*20,			//	u
	384*21,			//	v
	384*22,			//	w
	384*23,			//	x
	384*24,			//	y
	384*25,			//	z
	384*42,			//	{
	384*26,			//	|
	384*43,			//	}	
	384*26			//	~
};

RODATA const unsigned char menuFontMap[] = {
	52,			// ' ' 
	27,			//	!
	43,			//	"
	44,			//	#
	43,			//	$
	43,			//	%
	43,			//	&
	43,			//	'
	47,			//	(
	48,			//	)
	31,			//	*
	43,			//	+
	26,			//	,
	44,			//	-
	51,			//	.
	46,			//	/
	41,			//	0
	32,			//	1
	33,			//	2
	34,			//	3
	35,			//	4
	36,			//	5
	37,			//	6
	38,			//	7
	39,			//	8
	40,			//	9
	29,			//	:
	30,			//	;
	43,			//	<
	45,			//	=
	43,			//	>
	28,			//	?
	42,			//	@
	0,			//	A
	1,			//	B
	2,			//	C
	3,			//	D
	4,			//	E
	5,			//	F
	6,			//	G
	7,			//	H
	8,			//	I
	9,			//	J
	10,			//	K
	11,			//	L
	12,			//	M	
	13,			//	N
	14,			//	O
	15,			//	P
	16,			//	Q
	17,			//	R
	18,			//	S
	19,			//	T
	20,			//	U
	21,			//	V
	22,			//	W
	23,			//	X
	24,			//	Y
	25,			//	Z
	49,			//	[
	48,			//	\
	50,			//	]
	26,			//	^
	26,			//	_
	46,			//	`
	46,			//	`
	0,			//	a
	1,			//	b
	2,			//	c
	3,			//	d
	4,			//	e
	5,			//	f
	6,			//	g
	7,			//	h
	8,			//	i
	9,			//	j
	10,			//	k
	11,			//	l
	12,			//	m
	13,			//	n
	14,			//	o
	15,			//	p
	16,			//	q
	17,			//	r
	18,			//	s
	19,			//	t
	20,			//	u
	21,			//	v
	22,			//	w
	23,			//	x
	24,			//	y
	25,			//	z
	42,			//	{
	26,			//	|
	43,			//	}	
	26			//	~
};


//
//
//

RODATA const unsigned char text1[] = "trsi.. trsi.. wooohoooo!   ";

RODATA const unsigned char text2[] = "    - mr.spiv - rules -    ";

RODATA const unsigned char text3[] = 	"cb    THIS SCROLLER HAS THE CONTROL FOR EFFECTS... "
										"NOW THE AMPLITUDE SHOULD GO DOWN"
										"m";



